#ifndef READING_MACHINE__H
#define READING_MACHINE__H

#include <memory>
#include "Classifier.hpp"
#include "Strategy.hpp"
#include "FeatureFunction.hpp"

class ReadingMachine
{
  private :

  std::string name;
  std::unique_ptr<Classifier> classifier;
  std::unique_ptr<Strategy> strategy;
  std::unique_ptr<FeatureFunction> featureFunction;

  public :

  ReadingMachine(const std::string & filename);
  TransitionSet & getTransitionSet();
  Strategy & getStrategy();
};

#endif
